"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildCssLink = buildCssLink;
exports["default"] = buildCssLinks;

var _forEach = _interopRequireDefault(require("@arijs/frontend/isomorphic/utils/for-each"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var reSlashStart = /^\/*/;

function buildCssLink(item, elAdapter) {
  var link = elAdapter.initName('link');
  var path = String(item.opt.cssRel).replace(reSlashStart, '/');
  elAdapter.attrsAdd(link, {
    name: 'rel',
    value: 'stylesheet'
  });
  elAdapter.attrsAdd(link, {
    name: 'href',
    value: path
  });
  return link;
}

function buildCssLinks(list, elAdapter) {
  var links = elAdapter.initRoot();
  (0, _forEach["default"])(list, function (item) {
    elAdapter.childElement(links, buildCssLink(item, elAdapter));
  });
  return elAdapter.childrenGet(links);
}