"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = printHtml;

var _forEach = _interopRequireDefault(require("@arijs/frontend/isomorphic/utils/for-each"));

var _streamXmlParser = require("@arijs/stream-xml-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function printHtml(_ref, _ref2, rules) {
  var tree = _ref.tree,
      elAdapter = _ref.elAdapter;
  var _ref2$level = _ref2.level,
      level = _ref2$level === void 0 ? -1 : _ref2$level,
      printer = _ref2.printer;
  return new Promise(function (resolve, reject) {
    var am = _streamXmlParser.printerTransform.asyncMatcher(elAdapter);

    var nodesRep = [];
    (0, _forEach["default"])(rules, function (_ref3) {
      var name = _ref3.name,
          matcher = _ref3.matcher,
          _callback = _ref3.callback;
      am.addRule({
        matcher: matcher,
        callback: function callback(opt) {
          nodesRep.push({
            replaced: name,
            path: opt.path.concat(opt.node)
          });
          return _callback(opt);
        }
      });
    });
    return _streamXmlParser.printerTransform.async({
      tree: tree,
      elAdapter: elAdapter,
      transform: am.transform,
      level: level,
      printer: printer,
      callback: function cbTransformed(err, page) {
        return err ? reject(err) : resolve({
          page: page,
          nodesRep: nodesRep
        });
      }
    });
  });
}