"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = writeFile;

var _openDir = require("@arijs/frontend/server/utils/open-dir");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var reSep = /[\\\/]+/g;
var reDots = /^[.]*$/;

function writeFile(basePath, subPath, fileData) {
  return new Promise(function (resolve, reject) {
    var subDirs = subPath.split(reSep).filter(function (x) {
      return x && !reDots.test(x);
    });
    var fileName = subDirs.pop();
    (0, _openDir.openDirArray)(basePath, subDirs.slice(), function (err) {
      if (err) {
        return reject(err);
      }

      var outputPath = [basePath].concat(subDirs, [fileName]).join(_path["default"].sep);

      _fs["default"].writeFile(outputPath, fileData, function (err) {
        return err ? reject(err) : resolve();
      });
    });
  });
}